% Generic Riemannian Optimization Package(GROPT): matlab version.
%
% ImportGROPT - (script) Adds the necessary paths to use the GROPT package
%
% solvers - (directory) Solvers: Algorithms
%           It contains Riemannian algorithms. It is independent of
%           problems.
% drivers - (directory) Solver drivers for specific problems and
%           applications. The files in it contain objects related to the
%           problem. For example, function, gradient, action of Hessian,
%           retraction, vector transport, etc. The files in this folder
%           call algorithms in the solvers folder.
% others  - (directory) Tests of drivers
%           The files in this folder give the arguments in algorithms. For
%           example, the arguments in the cost function, the initial
%           iterate, parameters in the algorithms, etc. Test files call the
%           functions in the drivers.
%           User can run the files in the test folder.
%           tests(dir):
%             it contains the basic test files for the drivers in this
%             library.
%           WHuangThesis(dir):
%             it is to reproduce the experiments in Wen Huang's thesis.
%           Exp_RTRSR1_paper(dir)
%             it is to reproduce the experiments in the RTR-SR1 paper.
%           Exp_RBroydenBasic_paper(dir):
%             it is to reproduce the experiments in the Riemannian Broyden
%             basic paper.
% 
% Libraries and data sets:
%           Dynamic programming code is from or modified from
%           http://ssamg.stat.fsu.edu/software
%           Two images data sets are used. One is FLAVIA and from
%           http://flavia.sourceforge.net/
%           The other is MPEG-7 and from
%           http://www.dabi.temple.edu/~shape/MPEG7/dataset.html
% 
% If you have any suggestions or find any bugs, please free to contact me.
% Thank you.
% 
% Written by Wen Huang: email:huwst08@gmail.com
