function paper_Broyden_family()
% Reproduce the experiments in Wen Huang's Dissertation
% Test the performance of Riemannian Broyden family algorithms with
% different choices of \phi.
% 
% By Wen Huang
    tab = zeros(9, 9);
%     phis = [0, 0.2, 0.4, 0.6, 0.8, 0.9, 0.99, 0.999, 1];
    phis = [-2, 1];%, 0.8, 0.6, 0.4, 0.2, 0.1, 0.01, 0];
    row = 0;
    randseedsset = [1,3,5,7,9,11,13,15,17,19];
    global nSR1
    nSR1 = 0;
    for i = 1 : length(phis)
        tab(row + 1, i) = 0;
        tab(row + 2, i) = 0;
        tab(row + 3, i) = 0;
        tab(row + 4, i) = 0;
        tab(row + 5, i) = 0;
        tab(row + 6, i) = 0;
        tab(row + 7, i) = 0;
        tab(row + 8, i) = 0;
        tab(row + 9, i) = 0;
        for j = 1 : length(randseedsset)
            [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp, ave_time] = test_Brockett(phis(i), randseedsset(j));
            tab(row + 1, i) = tab(row + 1, i)+ length(X);
            tab(row + 2, i) = tab(row + 2, i) + nf;
            tab(row + 3, i) = tab(row + 3, i) + ng;
            tab(row + 4, i) = tab(row + 4, i) + nH;
            tab(row + 5, i) = tab(row + 5, i) + nV + nVp;
            tab(row + 6, i) = tab(row + 6, i) + nR;
            tab(row + 7, i) = tab(row + 7, i) + G(end);
            tab(row + 8, i) = tab(row + 8, i) + G(end)/G(1);
            tab(row + 9, i) = tab(row + 9, i) + ave_time;
        end
        tab(row + 1, i) = tab(row + 1, i) / length(randseedsset);
        tab(row + 2, i) = tab(row + 2, i) / length(randseedsset);
        tab(row + 3, i) = tab(row + 3, i) / length(randseedsset);
        tab(row + 4, i) = tab(row + 4, i) / length(randseedsset);
        tab(row + 5, i) = tab(row + 5, i) / length(randseedsset);
        tab(row + 6, i) = tab(row + 6, i) / length(randseedsset);
        tab(row + 7, i) = tab(row + 7, i) / length(randseedsset);
        tab(row + 8, i) = tab(row + 8, i) / length(randseedsset);
        tab(row + 9, i) = tab(row + 9, i) / length(randseedsset);
%         stiefelGS{i} = G;
    end

    fout = fopen('Thesis_Broyden_family_tab.txt','w');
    for i = 1 : 9
        for j = 1 : 9
            if(mod(i-1, 9) < 0)
                if(j < 9)
                    fprintf(fout,'%d & ',tab(i, j));
                else
                    fprintf(fout,'%d',tab(i, j));
                end
            else
                tabstr = outputfloat(tab(i, j));
                if(j < 9)
                    fprintf(fout,['$' tabstr '$ & ']);
                else
                    fprintf(fout,['$' tabstr '$']);
                end
            end
        end
        fprintf(fout,' \\\\\n');
    end
    fclose(fout);
    nSR1
    nSR1 = nSR1 / length(randseedsset) / 5
    
%     
%     figure('Position', [1, 1, 800, 300]);clf
%     set(0,'defaultaxesfontsize',10, ...
%        'defaultaxeslinewidth',0.7, ...
%        'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
%     set(0,'defaultlinemarkersize',10)
%     colors = hsv(9);
% %     colors = ['k', 'r', 'b', 'g', 'c', 'm', 'k', 'r', 'b'];
%     for i = 1 : 9
%         semilogy(1 : length(stiefelGS{i}), stiefelGS{i}, '.', 'MarkerEdgeColor', colors(i, :));%['.' colors(i)]);
%         hold on
%     end
%     axis square
%     axis fill
%     axis tight
%     xlabel('iter.')
%     ylabel('|grad f|')
%     title('Brockett on the Stiefel manifold');
%     legend('D', '1.0', '0.8', '0.6', '0.4', '0.2', '0.1', '0.01', '0', 'Location', 'SouthWest');
end

function str = outputfloat(x)
    if(x <= 0)
        str = '';
        return;
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [strx '_{' num2str(p) '}'];
    else
        str = strx;
    end
end

function [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp, ave_time] = test_Brockett(pp, randseed)
    fprintf('test for Brockett problem. \n');
    fprintf('X^* = arg min_{x in St(p, n)} trace(X^T B X N), where B is an n by n matrix. \n');
    r = rand();
    r = floor(r * 10000);
%     r = 1;
    r = randseed;
    rand('state', r);
    randn('state', r);
    method = 1;
    n = 12;
    p = 8;
    fprintf('In this case, n = %d, p = %d. B and x0 are chosen randomly. Random seed is %d \n', n, p, r);
    
    Q = orth(randn(n, n));
%     D = diag([ones(1,p), ones(1,n-p) + 0.1]);
%     D = diag([zeros(1,p), zeros(1,n-p) + 0.01]);
    D = diag([zeros(1,p), (1:n-p)/(n-p) * 0.01]);
%     D = diag([(1 : p) / p, ones(1,n-p) + 10]);
%     D = diag([(1 : p), ((p+1) : n) + 10]);
%     D = diag([1:n]);
    B = Q * D * Q';
%     B = randn(n, n);
%     B = B + B';
    
    N = diag(1:p);
    x1U = randn(n, p);
    [x1.U, r] = qr(x1U, 0);
    basis_x1 = full(build_bases_embedded(x1.U));
    nnn = size(basis_x1, 2);
    T = eye(nnn);
    T(end, end) = 10000;
    B0 = basis_x1 * T * basis_x1';
%     B0 = eye(n * p);
    H0 = B0;
    retraction = 6;
    VT = 7;
    if(VT == 7 || VT == 13 || VT == 19 || VT == 25)
        d = 0.5 * p * (p - 1) + (n - p) * p;
        H0 = eye(d);
%         B0 = eye(d);
%         B0(end, end) = 10000;
%         B0(end - 1, end - 1) = 10;
%         for i = floor(d * 0.8) + 1 : d
%             H0(end, end) = 1/10000;
%         end
%         for i = floor(d * 0.6) + 1 : floor(d * 0.8)
%             H0(end, end) = 1/50;
%         end
        H0(end, end) = 1/10000;
        H0(end - 1, end - 1) = 1/50;
        x1.Up = null(x1.U');
    end
    params.x0 = x1;
    params.H0 = H0;
%     params.B0 = B0;
    params.error = 1e-6;
    params.StopCriterion = 3;
    params.max_t = 500000;
    params.debug = 0;
    params.manifold = 2;
    params.m = 4;
    params.alpha = 1e-4;
    params.beta = 0.999;
    params.minstepsize = eps;
    params.maxstepsize = 200;
    params.retraction = retraction;
    params.vector_transport = VT;
    params.restart = 0;
    params.keepnumX = 2;
    params.nu = 0;
    times = 0;
    params.linesearch = 2;
    total_timecost = 0;
    if(pp >= 0)
        fns.phi = @(x, y, s, B, inp_s_y, sBs, fns, v, times)phi(x, y, s, B, inp_s_y, sBs, fns, v, times, pp);
    else
        fns.phi = @(x, y, s, B, inp_s_y, sBs, fns, v, times)phi_intr_stiefel(x, y, s, B, inp_s_y, sBs, fns, v, times, pp);
    end
    while(total_timecost < 60 && times < 5)
        fprintf('%d: ', times);
        [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp] = driver_Brockett(B, N, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    ave_time = total_timecost / times;
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end

function output = phi_intr_stiefel(x, y, s, H, inp_s_y, yHy, fns, v, times, pp)
    if(pp > -1)
        %% negative constant
%         invBy = linsolve(B, y);
%         u = fns.inpro(x, y, invBy) * sBs / inp_s_y / inp_s_y;
%         output = - pp / (1 - u);
%         if(output > 0)
%             output = 0;
%         end
    elseif(pp == -2)
        %% Davidon's update
        Bs.TV = linsolve(H, s.TV);
        sBs = fns.inpro(x, s, Bs);
        if(inp_s_y < 2 * sBs * yHy / (sBs + yHy))
            output = inp_s_y * (sBs - inp_s_y) / (sBs * yHy - inp_s_y^2);
        else
            global nSR1
            nSR1 = nSR1 + 1;
%             nSR1
            output = inp_s_y / (inp_s_y - yHy);
        end
%         output = min(output, 1);%%---------
%     elseif(pp == -3)
%         %% Bryd's update
%         invBy = linsolve(B, y);
%         u = fns.inpro(x, y, invBy) * sBs / inp_s_y / inp_s_y;
%         vv = fns.inpro(x, v, linsolve()); %% problem
%         output = 1 / sBs / vv + 1 / (1 - u);
    end

%     output = 0;
end

function p = phi(x, y, s, B, inp_s_y, sBs, fns, v, times, p)
end

function output = build_bases(x)
%     [n, p] = size(x);
%     x_perp = null(x');
%     output = sparse(n * p, p * (n - p));
%     for i = 1 : p
%         output((i - 1) * n + 1 : i * n, (i - 1) * (n - p) + 1 : i * (n - p)) = x_perp;
%     end

    [n, p] = size(x);
    x_perp = null(x');
    x_perps = mat2cell(repmat(x_perp, 1, p), [n], (n - p) * ones(1, p));
    x_perps{1} = sparse(x_perps{1});
    output = blkdiag(x_perps{:});
end

function output = build_bases_embedded(x)
    [n, p] = size(x);
    x_perp = null(x');
    x = x / sqrt(2);
    d = n * p - p * (p + 1) / 2;
    output = sparse(n * p, d);
%     output = zeros(n * p, d);
    col = 1;
    for i = 2 : p
        for j = i : p
            output((i - 2) * n + 1 : (i - 1) * n, col) = - x(:, j);
            output((j - 1) * n + 1 : j * n, col) = x(:, i - 1);
            col = col + 1;
        end
    end
    for i = 1 : p
        output((i - 1) * n + 1 : i * n, col : col + n - p - 1) = x_perp(1 : n, 1 : n - p);
        col = col + n - p;
    end
end
