function test_Brockett
% test file for Brockett cost function on the Stiefel manifold.
% X^* = arg min_{X in St(p, n)} trace(X^T B X N), where B is an n by n matrix.
% 
% By Wen Huang
    fprintf('test for Brockett problem. \n');
    fprintf('X^* = arg min_{X in St(p, n)} trace(X^T B X N), where B is an n by n matrix. \n');
    r = rand();
    r = floor(r * 10000);
    r = 1;
    rand('state', r);
    randn('state', r);
    n = 12;
    p = 8;
    fprintf('In this case, n = %d, p = %d. B and x0 are chosen randomly. Random seed is %d \n', n, p, r);
    fprintf('which algorithm do you want to test: \n');
    fprintf('2, RBFGS \n');
    fprintf('3, LRBFGS \n');
    fprintf('10, RWRBFGS \n');
    fprintf('13, check gf and Hessian\n');
    fprintf('otherwise, break \n');
    method = input('please input: ');
    if(method < 1 || method > 13)
        fprintf('exit! \n');
        return;
    end
    fprintf('which retraction do you want to test: \n');
    fprintf('1, exp (quotient) \n');
    fprintf('2, exp (embedded) \n');
    fprintf('3, qf (quotient)\n');
    fprintf('4, qf (embedded)\n');
    fprintf('5, construct (quotient)\n');
    fprintf('6, construct (embedded)\n');
    fprintf('otherwise, break \n');
    Retraction = input('please input: ');
    if(Retraction < 1 || Retraction > 6)
        fprintf('exit! \n');
        return;
    end
    
    fprintf('which vector transport do you want to test: \n');
    fprintf('1, Emb&Quo nonIso: vector transport by projection \n')
    fprintf('2, Emb Iso: parallel transport \n')
    fprintf('3, Emb Iso: direct-rotation with basis on tangent space \n')
    fprintf('4, Emb Iso: direct-rotation with basis on normal space \n')
    fprintf('5, Emb Iso: smooth basis on tangent space \n')
    fprintf('6, Emb Iso: smooth basis on normal space \n')
    fprintf('7, Emb Iso: intrinsic approach \n')
    fprintf('8, Quo Iso: parallel transport \n')
    fprintf('9, Quo Iso: direct-rotation with basis on horizontal space \n')
    fprintf('10,Quo Iso: direct-rotation with basis on vertical space \n')
    fprintf('11,Quo Iso: smooth basis on horizontal space \n')
    fprintf('12,Quo Iso: smooth basis on vertical space \n')
    fprintf('13,Quo Iso: intrinsic approach \n')
    fprintf('14,Emb Locking-Iso(qf): direct-rotation with basis on tangent space \n')
    fprintf('15,Emb Locking-Iso(qf): direct-rotation with basis on normal space \n')
    fprintf('16,Emb Locking-Iso(qf): smooth basis on tangent space \n')
    fprintf('17,Emb Locking-Iso(qf): smooth basis on normal space \n')
    fprintf('18,Emb Locking-Iso(qf): construct vector transport \n')
    fprintf('19,Emb Locking-Iso(qf): intrinsic approach \n')
    fprintf('20,Quo Locking-Iso(qf): direct-rotation with basis on horizontal space \n')
    fprintf('21,Quo Locking-Iso(qf): direct-rotation with basis on vertical space \n')
    fprintf('22,Quo Locking-Iso(qf): smooth basis on horizontal space \n')
    fprintf('23,Quo Locking-Iso(qf): smooth basis on vertical space \n')
    fprintf('24,Quo Locking-Iso(qf): construct vector transport \n')
    fprintf('25,Quo Locking-Iso(qf): intrinsic approach \n')
    fprintf('26,Emb Locking-nonIso(qf): vector transport by projection \n')
    fprintf('otherwise, break \n');
    VT = input('please input: ');
    if(VT < 1 || VT > 26)
        fprintf('exit! \n');
        return;
    end
%     ------1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26
%     LC_M = [0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
%             0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
%             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0;
%             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0;
%             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
%             0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;];
%     if((method <= 3 || method == 11) && ~LC_M(Retraction, VT))
%         fprintf('Locking condition is not satisfied. Algorithm may fail. \n')
%         fprintf('Do you still want to run it? \n')
%         fprintf('1: run \n')
%         fprintf('otherwise: exit \n')
%         flag = input('input: ');
%         if(isempty(flag) || flag ~= 1)
%             fprintf('exit! \n');
%             return;
%         end
%     end
    B = randn(n, n);
    B = B + B';
    N = sparse(diag(1:p));
    
    x1U = randn(n, p);
    [x1.U, r] = qr(x1U, 0);

    if(method == 1 || method == 2 || method == 10)
        H0 = eye(n * p);
    end
    if(method == 5)
        B0 = eye(n * p);
    end
    if(VT == 7 || VT == 13 || VT == 19 || VT == 25)
        d = 0.5 * p * (p - 1) + (n - p) * p;
        if(method == 1 || method == 2 || method == 10)
            H0 = eye(d);
        end
        if(method == 5)
            B0 = eye(d);
        end
        x0 = x1.U;
        clear('x1');
        x1.U = x0;
        x1.Up = null(x0');
    end

    params.x0 = x1;
    if(method == 1 || method == 2 || method == 10)
        params.H0 = H0;
    end
    if(method == 5)
        params.B0 = B0;
    end
    params.error = 1e-6;
    params.StopCriterion = 3;
    params.max_t = 2000;
    params.debug = 1;
    params.isplot = 0;
    params.manifold = 2;
    params.m = 4;
    params.alpha = 1e-4;
    params.beta = 0.999;
    params.Delta_bar = inf;
    params.Delta0 = 1;
    params.min_Delta = eps;
    params.minstepsize = eps;
    params.maxstepsize = 200;
    params.retraction = Retraction;
    params.vector_transport = VT;
    params.linesearch = 2;
    params.keepnumX = 2;
    params.nu = 0;
    params.isplot = 1;
    
    fns = {};

    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp] = driver_Brockett(B, N, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end

function [output, R] = qf(B)
    k = size(B, 2);
    [output, R] = qr(B, 0);
    diagR = diag(R);
    diagR(diagR == 0) = 1;
    output = output * spdiags(sign(diagR), 0, k, k);
end
